﻿import {Page, NavParams, NavController} from 'ionic/ionic';
import {Validators, Control, NgControl, ControlGroup} from 'angular2/angular2';

import {TicketView} from '../ticket/ticket';
import {ForbesView} from '../forbes/forbes';
import {VotingView} from '../voting/voting';
import {CollectView} from '../collect/collect';


import {HttpService} from '../../../units/http';
import {ConsoleService} from '../../../units/console';


@Page({
    templateUrl: 'app/02.event/category/category.html'
})
export class CategoryPage {
    constructor(nav: NavController, params: NavParams, http: HttpService, console: ConsoleService) {

        this.nav = nav;
        this.http = http;
        this.console = console;

        // 初始化配置
        // ---------------------------------
        this.todo = params.get('todo');
        this.category = params.get('category');
        
        // this.form = new ControlGroup({
        //     state: new Control('doing', Validators.required)
        // });
        this.form = 'doing';


        // 正在进行： 抢票 & ...
        // ---------------------------------
        if(this.category == 'ticket'){
            let doingTicketData = {
                'uid': JSON.parse(localStorage.getItem('user')).uid,
                'token': JSON.parse(localStorage.getItem('user')).token,

                'curPage' : JSON.parse(localStorage.getItem('post')).event.index,
                'pageSize': JSON.parse(localStorage.getItem('post')).event.display,
                'orderBy': JSON.parse(localStorage.getItem('post')).event.orderBy,
                'order': JSON.parse(localStorage.getItem('post')).event.order,
                'state': JSON.parse(localStorage.getItem('post')).event.doingState
            }
            this.http.server(this.todo,doingTicketData).subscribe(
                doingTicketResponse => {
                    this.console.log('正在进行[抢票]',[]); //JSON.stringify(doingTicketResponse.dataRows)
                    this.doingEvent = doingTicketResponse.dataRows;
                }    
            );

            let overTicketData = {
                'uid': JSON.parse(localStorage.getItem('user')).uid,
                'token': JSON.parse(localStorage.getItem('user')).token,

                'curPage' : JSON.parse(localStorage.getItem('post')).event.index,
                'pageSize': JSON.parse(localStorage.getItem('post')).event.display,
                'orderBy': JSON.parse(localStorage.getItem('post')).event.orderBy,
                'order': JSON.parse(localStorage.getItem('post')).event.order,
                'state': JSON.parse(localStorage.getItem('post')).event.overState
            }
            this.http.server(this.todo,overTicketData).subscribe(
                overTicketResponse => {
                    this.console.log('已经结束[抢票]',[]); //JSON.stringify(topTicketResponse.dataRows)
                    this.overEvent = overTicketResponse.dataRows;
                }    
            );
        }

        if(this.category == 'collect'){

            this.show = false;
            // 显示分类：活动
            // ---------------------------------
            let doingData = {
                'uid': JSON.parse(localStorage.getItem('user')).uid,
                'token': JSON.parse(localStorage.getItem('user')).token,

                'type':'3',
                'curPage' : '1',
                'pageSize': '20',
                'state':'1',
                'orderBy':'createTime',
                'order':'desc'
            }
            this.http.server(this.todo, doingData).subscribe(
                doingEvent => {
                    this.doingEvent = doingEvent.dataRows;
                    this.console.log('正在进行[征集]：',[this.doingEvent]);
                }    
            );

            let overData = {
                'uid': JSON.parse(localStorage.getItem('user')).uid,
                'token': JSON.parse(localStorage.getItem('user')).token,

                'type':'3',
                'curPage' : '1',
                'pageSize': '20',
                'state':'0',
                'orderBy':'createTime',
                'order':'desc'
            }
            this.http.server(this.todo, overData).subscribe(
                overEvent => {
                    this.overEvent = overEvent.dataRows;
                    this.console.log('已经结束[征集]：', [this.overEvent]);
                }    
            );
        }

        if(this.category == 'voting'){
            let doingData = {
                'uid': JSON.parse(localStorage.getItem('user')).uid,
                'token': JSON.parse(localStorage.getItem('user')).token,

                'type':'2',
                'curPage' : '1',
                'pageSize': '20',
                'state':'1',
                'orderBy':'createTime',
                'order':'desc'
            }
            this.http.server(this.todo, doingData).subscribe(
                doingEvent => {
                    this.doingEvent = doingEvent.dataRows;
                    this.console.log('正在进行[投票]：', [this.doingEvent]);
                }    
            );

            let overData = {
                'uid': JSON.parse(localStorage.getItem('user')).uid,
                'token': JSON.parse(localStorage.getItem('user')).token,

                'type':'2',
                'curPage' : '1',
                'pageSize': '20',
                'state':'0',
                'orderBy':'createTime',
                'order':'desc'
            }
            this.http.server(this.todo, overData).subscribe(
                overEvent => {
                    this.overEvent = overEvent.dataRows;
                    this.console.log('已经结束[投票]：', [this.overEvent]);
                }    
            );
        }

        if(this.category == 'forbes'){
            let doingData = {
                'uid': JSON.parse(localStorage.getItem('user')).uid,
                'token': JSON.parse(localStorage.getItem('user')).token,

                'type':'1',
                'curPage' : '1',
                'pageSize': '20',
                'state':'1',
                'orderBy':'createTime',
                'order':'desc'
            }
            this.http.server(this.todo, doingData).subscribe(
                doingEvent => {
                    this.doingEvent = doingEvent.dataRows;
                    this.console.log('正在进行[活动]：',[this.doingEvent]);
                }    
            );

            let overData = {
                'uid': JSON.parse(localStorage.getItem('user')).uid,
                'token': JSON.parse(localStorage.getItem('user')).token,

                'type':'1',
                'curPage' : '1',
                'pageSize': '20',
                'state':'0',
                'orderBy':'createTime',
                'order':'desc'
            }
            this.http.server(this.todo, overData).subscribe(
                overEvent => {
                    this.overEvent = overEvent.dataRows;
                    console.log('已经结束[活动]：',[this.overEvent]);
                }    
            );
        }
    }


    //活动详情：抢票、投票、征集、排行
    // ---------------------------------
    viewEvent(event){
        if(this.category == 'ticket'){
            this.nav.push(TicketView,{
                ticket:event
            });
        }

        if(this.category == 'voting'){
            this.nav.push(VotingView,{
                voting:event
            });
        }

        if(this.category == 'forbes'){
            this.nav.push(ForbesView,{
                forbes:event
            });
        }

        if(this.category == 'collect'){
            this.nav.push(CollectView,{
                collect:event
            });
        }

    }

    onSegmentClicked(value) {
            this.form = value;
          }


        onSegmentChanged(value) {
            this.form = value;
          }

    //异常处理：暂无活动
    // ---------------------------------
    back(){
        this.nav.pop();
    }
}
