﻿import {Page, Popup, NavParams, NavController} from 'ionic/ionic';

import {HttpService} from '../../../units/http';
import {ConsoleService} from '../../../units/console';


@Page({
    templateUrl: 'app/02.event/ticket/ticket.html'
})
export class TicketView {
    constructor(nav: NavController, params: NavParams, popup: Popup, http: HttpService, console: ConsoleService) {

        this.nav = nav;
        this.http = http;
        this.popup = popup;
        this.console = console;

        // 初始化参数
        // ---------------------------------
        this.ticket = params.get('ticket');

        //傻瓜写法  封装失败 找不到方法
        this.date = new Date(this.ticket.beginTime);
        this.month = this.date.getMonth() + 1;
        this.day = this.date.getDate();
        this.hour = this.date.getHours();
        this.min = this.date.getMinutes();

        if (this.min < 10) {
            this.min = "0" + this.min;
        }

        this.beginTime =  this.month + "月" + this.day + "日 " + this.hour + ":" + this.min;
        

        //傻瓜写法  封装失败 找不到方法
        this.date = new Date(this.ticket.endTime);
        this.month = this.date.getMonth() + 1;
        this.day = this.date.getDate();
        this.hour = this.date.getHours();
        this.min = this.date.getMinutes();

        if (this.min < 10) {
            this.min = "0" + this.min;
        }
        this.endTime =  this.month + "月" + this.day + "日 " + this.hour + ":" + this.min;

        let isTicketData = {
            'uid': JSON.parse(localStorage.getItem('user')).uid,
            'token': JSON.parse(localStorage.getItem('user')).token,
            'signUpId':this.ticket.id
        }

        this.http.server(JSON.parse(localStorage.getItem('todo')).event.isTicket, isTicketData).subscribe(
            isTicketResponse => {

                this.isJoin = isTicketResponse.isJoin;
                this.console.log('是否参加？',[this.ticket.id, this.isJoin]);
            }    
        );
    }

    // 参与活动
    // ---------------------------------
    joinTicket(){
        let data = {
            'uid': JSON.parse(localStorage.getItem('user')).uid,
            'token': JSON.parse(localStorage.getItem('user')).token,
            'id':this.ticket.id
        }
        
        this.http.server(JSON.parse(localStorage.getItem('todo')).event.joinTicket, data).subscribe(
            joinData => {
                if(joinData.flag && joinData.isSuccess){
                    this.popup.alert({
                        title:'提示',
                        template:'报名成功！'
                    });
                    this.isJoin = true;
                }else{
                    this.popup.alert({
                        title:'提示',
                        template:'活动还未开始或已结束！'
                    });
                }

                console.log(joinData);
            }    
        );
    }

}
