﻿import {Page, NavController} from 'ionic/ionic';

import {NewsView} from './view/view';

import {HttpService} from '../../units/http';
import {ConsoleService} from '../../units/console';

@Page({
    templateUrl: 'app/03.news/news.html'
})
export class NewsPage {
    constructor(nav: NavController, http: HttpService, console: ConsoleService) {

        this.nav = nav;

        this.http = http;
        this.console = console;

        // 初始化配置
        // ---------------------------------
        this.loadText = '点击加载更多';
        this.debug = JSON.parse(localStorage.getItem('app')).debug == 'true' ? true : false;
        this.index = JSON.parse(localStorage.getItem('post')).news.index;
        this.display = JSON.parse(localStorage.getItem('post')).news.display;
        this.allNewsData = {
            'uid': JSON.parse(localStorage.getItem('user')).uid,
            'token': JSON.parse(localStorage.getItem('user')).token,
            "curPage": this.index,
            "pageSize": this.display
        }
        this.http.server(JSON.parse(localStorage.getItem('todo')).news.all, this.allNewsData).subscribe(
            allNewsResponse => {
                this.console.log('明星资讯',[]); //JSON.stringify(allNewsResponse.dataRows)
                this.allNews = allNewsResponse.dataRows;
            },
            error => {
                // TODO-错误页面
            }
        );
    }


    // 资讯详情
    // ---------------------------------
    view(news){
        this.nav.push(NewsView,{
            news : news
        });
    }

    // 加载更多
    // ---------------------------------
    loadMore(){
        this.display = parseInt('10',this.display) + 10;
        console.log('加载数量：' + this.display);
        this.allNewsData = {
            'uid': JSON.parse(localStorage.getItem('user')).uid,
            'token': JSON.parse(localStorage.getItem('user')).token,
            "curPage": this.index,
            "pageSize": this.display
        }
        console.log('加载更多：' ,this.allNewsData);
        this.http.server(JSON.parse(localStorage.getItem('todo')).news.all, this.allNewsData).subscribe(
            allNewsResponse => {
                this.console.log('加载更多',[JSON.stringify(allNewsResponse.dataRows)]); //JSON.stringify(allNewsResponse.dataRows)
                this.allNews = allNewsResponse.dataRows;
            },
            error => {
                // TODO-错误页面
            }
        );
    }


    // 下拉刷新
    // ---------------------------------
    doRefresh(refresher) {
        //this.loadText = '点击加载更多';
        this.index = JSON.parse(localStorage.getItem('post')).news.index;
        this.allNewsData = {
            'uid': JSON.parse(localStorage.getItem('user')).uid,
            'token': JSON.parse(localStorage.getItem('user')).token,
            "curPage": this.index,
            "pageSize": this.display
        }
        this.http.server(JSON.parse(localStorage.getItem('todo')).news.all, this.allNewsData).subscribe(
            allNewsResponse => {
                this.console.log('下拉刷新',[]); //JSON.stringify(allNewsResponse.dataRows)
                this.allNews = allNewsResponse.dataRows;
                refresher.complete();
            },
            error => {
                // TODO-错误页面
            }
        );
    }

    // 加载更多
    // ---------------------------------


    // 页面生命周期
    // ---------------------------------
    //onPageLoaded(){
    //    this.console.log('NewsPage',['onPageLoaded','页面加载完成！']);
    //}

    //onPageWillEnter(){
    //    this.console.log('NewsPage',['onPageWillEnter','页面即将激活！']);
    //}

    onPageDidEnter(){
        //this.loadText = '点击加载更多';
        console.log('NewsRefresh: ' + localStorage.getItem('NewsRefresh'));
        
        if(localStorage.getItem('NewsRefresh') == 'ture'){
            this.allNewsData = {
                'uid': JSON.parse(localStorage.getItem('user')).uid,
                'token': JSON.parse(localStorage.getItem('user')).token,
                "curPage": '1',
                "pageSize": this.display
            }
            this.http.server(JSON.parse(localStorage.getItem('todo')).news.all, this.allNewsData).subscribe(
                allNewsResponse => {
                    this.console.log('返回刷新',[]); //JSON.stringify(allNewsResponse.dataRows)
                    this.allNews = allNewsResponse.dataRows;
                },
                error => {
                    // TODO-错误页面
                }
            );
            
            localStorage.setItem('NewsRefresh','false');
        }
 
        this.console.log('NewsPage',['onPageDidEnter','页面已经激活！']);
    }

    //onPageWillLeave (){
    //    this.console.log('NewsPage',['onPageWillLeave','页面即将退出！']);
    //}

    //onPageDidLeave() {
    //    this.console.log('NewsPage',['onPageDidLeave','页面已经退出！']);
    //}

    //onPageWillUnload (){
    //    this.console.log('NewsPage',['onPageWillUnload','页面即将销毁！']);
    //}

    //onPageDidUnload (){
    //    this.console.log('NewsPage',['onPageDidUnload','页面已经销毁！']);
    //}
}


