﻿import {Page, Modal, Platform ,NavParams, NavController, ActionSheet} from 'ionic/ionic';
import {Control, Validators, ControlGroup} from 'angular2/angular2';

import {TalkPage} from '../talk';

import {HttpService} from '../../../units/http';
import {ConsoleService} from '../../../units/console';


@Page({
    templateUrl: 'app/04.talk/post/post.html',
    providers: [HttpService, ConsoleService]
})
export class TalkPost {
    constructor(nav: NavController, params: NavParams, modal: Modal, platform: Platform, actionSheet: ActionSheet,http: HttpService, console: ConsoleService) {
        this.nav = nav;
        this.modal = modal;
        this.platform = platform;
        this.actionSheet = actionSheet;

        this.http = http;
        this.console = console;


        // 初始化参数
        // ---------------------------------  
        this.media = '';
        this.starsId = '';
        window.count = 0;
        this.image = 'local/res/error.png';
        localStorage.removeItem('media');

        this.platform.is('android')? this.buttons = [
          { text: '拍照', icon: 'camera'},
          { text: '媒体库', icon: 'image' }
        ] : this.buttons = [
          { text: '拍照'},
          { text: '手机相册' }
        ]

        this.form = new ControlGroup({
            content: new Control('', Validators.required)
        });

        this.qiniuTokenData = {
            'uid': JSON.parse(localStorage.getItem('user')).uid,
            'token': JSON.parse(localStorage.getItem('user')).token,
            'bucket': JSON.parse(localStorage.getItem('post')).qiniu.talk.host,
            'expires': JSON.parse(localStorage.getItem('post')).qiniu.expires
        }
        this.http.server(JSON.parse(localStorage.getItem('todo')).qiniu.token, this.qiniuTokenData).subscribe(
            qiniuTokenResponse => {
                this.qiniuToken = qiniuTokenResponse.uptoken;
                //alert(this.qiniuToken);
            }
        );

        // 已关注明星
        // ---------------------------------  
        this.addedStarData = {
            'uid': JSON.parse(localStorage.getItem('user')).uid,
            'token': JSON.parse(localStorage.getItem('user')).token,
            'curPage': '1',
            'pageSize': '8',
            'orderBy': 'id',
            'order':'desc'
        }
        this.http.server(JSON.parse(localStorage.getItem('todo')).star.added, this.addedStarData).subscribe(
            addedStarResponse => {
                this.stars = addedStarResponse.dataRows;
                this.stars.forEach(star => {
                    this.starsId == '' ? this.starsId = star.starId : this.starsId += (',' + star.starId);
                });
                this.console.log('已关注明星：',[JSON.stringify(addedStarResponse.dataRows)]); // JSON.stringify(newReplyResponse.dataRows)
            }
        );

        for(let i = 0; i < 8; i++){
            var image = document.getElementById('image-' + i);
            image.style.display = 'none';

            var span = document.getElementById('span-' + i);
            span.style.display = 'none';

        }

        var span = document.getElementById('span-0');
        span.style.display = 'block';
    }



    // 添加图片
    // ---------------------------------
    addImage(){
        if(window.count > 0 && localStorage.getItem('media') && localStorage.getItem('media') != ''){
            //alert(localStorage.getItem('media') );
            this.uploadMedia();
        }
        this.actionSheet.open({
            buttons: this.buttons,
            destructiveText: '',
            titleText: '上传图片',
            cancelText: '取消',
            cancel: () => {
                localStorage.removeItem('media');
            },
            destructiveButtonClicked: () => {
                // TODO-暂无删除
            },
            buttonClicked: (index) => {
                console.log('已选择：' + index);
                if (index == '0') {
                    navigator.camera.getPicture(
                        function (imageData) {
                            if(window.count < 7){
                                var span_prev = document.getElementById('span-' + window.count);
                                span_prev.style.display = 'none';

                                var span_next = document.getElementById('span-' + (window.count + 1));
                                span_next.style.display = 'block';
                            
                                var image = document.getElementById('image-' + window.count);
                                image.src = "data:image/jpeg;base64," + imageData;
                                image.style.display = 'block';

                                window.count ++ ;
                                localStorage.setItem('media':imageData);
                            }else{
                                var span_prev = document.getElementById('span-' + window.count);
                                span_prev.style.display = 'none';
                            
                                var image = document.getElementById('image-' + window.count);
                                image.src = "data:image/jpeg;base64," + imageData;
                                image.style.display = 'block';

                                localStorage.setItem('media':imageData);
                            }

                        }, 
                       function (error) {
                           localStorage.removeItem('media');
                       }, 
                       {
                           quality: 80,
                           destinationType: window.Camera.DestinationType.DATA_URL,
                           sourceType: window.Camera.PictureSourceType.CAMERA,
                           allowEdit: false,
                           encodingType: window.Camera.EncodingType.JPEG,
                           targetWidth: 1080,
                           targetHeight: 1280,
                           popoverOptions: window.CameraPopoverOptions,
                           saveToPhotoAlbum: false
                       });
                    this.actionSheetRef.close();
                }

                if(index == '1'){
                    navigator.camera.getPicture(
                            function (imageData) {
                                if(window.count < 7){
                                    var span_prev = document.getElementById('span-' + window.count);
                                    span_prev.style.display = 'none';

                                    var span_next = document.getElementById('span-' + (window.count + 1));
                                    span_next.style.display = 'block';
                            
                                    var image = document.getElementById('image-' + window.count);
                                    image.src = "data:image/jpeg;base64," + imageData;
                                    image.style.display = 'block';

                                    window.count ++ ;
                                    localStorage.setItem('media':imageData);
                                }else{
                                    var span_prev = document.getElementById('span-' + window.count);
                                    span_prev.style.display = 'none';
                            
                                    var image = document.getElementById('image-' + window.count);
                                    image.src = "data:image/jpeg;base64," + imageData;
                                    image.style.display = 'block';

                                    localStorage.setItem('media':imageData);
                                }
                            }, 
                           function (error) {

                           }, 
                           {
                               quality: 80,
                               destinationType: window.Camera.DestinationType.DATA_URL,
                               sourceType: window.Camera.PictureSourceType.SAVEDPHOTOALBUM,
                               allowEdit: true,
                               encodingType: window.Camera.EncodingType.JPEG,
                               targetWidth: 400,
                               targetHeight: 400,
                               popoverOptions: window.CameraPopoverOptions,
                               saveToPhotoAlbum: false
                           });
                    this.actionSheetRef.close();
                }
            }

        }).then(actionSheetRef => {
            this.actionSheetRef = actionSheetRef;
        });
    }


    // 上传图像
    // ---------------------------------
    uploadMedia(){
        this.http.uploader(this.qiniuToken, localStorage.getItem('media')).subscribe(
            data => {
                //alert(data);
                if(data.hash){
                    this.media == '' ? this.media = JSON.parse(localStorage.getItem('post')).qiniu.talk.http + data.key : this.media += (',' + JSON.parse(localStorage.getItem('post')).qiniu.talk.http + data.key);
                    //alert('上传成功：');
                }
            }
        );
    }
    
    push(){
        if(localStorage.getItem('media') && localStorage.getItem('media') != ''){
            this.http.uploader(this.qiniuToken, localStorage.getItem('media')).subscribe(
                data => {
                    //alert(data);
                    if(data.hash){
                        this.media == '' ? this.media = JSON.parse(localStorage.getItem('post')).qiniu.talk.http + data.key : this.media += (',' + JSON.parse(localStorage.getItem('post')).qiniu.talk.http + data.key);
                        let talkData = {
                            'uid': JSON.parse(localStorage.getItem('user')).uid,
                            'token': JSON.parse(localStorage.getItem('user')).token,
                            'starIds':this.starsId,
                            'content': this.form.value.content,
                            'media':this.media,
                            'mediaType':'1'
                        }
                        this.http.server(JSON.parse(localStorage.getItem('todo')).talk.post,talkData).subscribe(
                            data => {
                                if(data.flag && data.isSuccess){
                                    localStorage.removeItem('media');
                                    window.count = 0;
                                    localStorage.setItem('talkPost','true');
                                    this.nav.pop();
                                }
                            }    
                        );
                    }
                }
            );      
        }else{
            let talkData = {
                'uid': JSON.parse(localStorage.getItem('user')).uid,
                'token': JSON.parse(localStorage.getItem('user')).token,
                'starIds':this.starsId,
                'content': this.form.value.content,
                'media':this.media,
                'mediaType':'1'
            }
            this.http.server(JSON.parse(localStorage.getItem('todo')).talk.post,talkData).subscribe(
                data => {
                    if(data.flag && data.isSuccess){
                        localStorage.removeItem('media');
                        window.count = 0;
                        localStorage.setItem('talkPost','true');
                        this.nav.pop();
                        //this.modal.get().close();
                    }
                }    
            );
        }  
    }

    close(){
        localStorage.setItem('talkPost','false');
        this.nav.pop();
    }

    // 页面生命周期
    // ---------------------------------
    //onPageLoaded(){
    //    this.console.log('TalkPost',['onPageLoaded','页面加载完成！']);
    //}

    //onPageWillEnter(){
    //    this.console.log('TalkPost',['onPageWillEnter','页面即将激活！']);
    //}

    //onPageDidEnter(){
    //    this.console.log('TalkPost',['onPageDidEnter','页面已经激活！']);
    //}

    //onPageWillLeave (){
    //    this.console.log('TalkPost',['onPageWillLeave','页面即将退出！']);
    //}

    //onPageDidLeave() {
    //    this.console.log('TalkPost',['onPageDidLeave','页面已经退出！']);
    //}

    //onPageWillUnload (){
    //    this.console.log('TalkPost',['onPageWillUnload','页面即将销毁！']);
    //}

    //onPageDidUnload (){
    //    this.console.log('TalkPost',['onPageDidUnload','页面已经销毁！']);
    //}
}
