﻿import {Page, IonicApp, Modal, NavController} from 'ionic/ionic';

import {TalkView} from './view/view';
import {TalkPost} from './post/post';

import {HttpService} from '../../units/http';
import {ConsoleService} from '../../units/console';

@Page({
    templateUrl: 'app/04.talk/talk.html'
})
export class TalkPage {
    constructor(app: IonicApp, nav: NavController, modal: Modal, http: HttpService, console: ConsoleService) {

        this.nav = nav;
        this.app = app;
        this.modal = modal;

        this.http = http;
        this.console = console;

        // 初始化配置
        // ---------------------------------
        this.medias = [];
        this.index = JSON.parse(localStorage.getItem('post')).talk.index;
        this.pageSize = JSON.parse(localStorage.getItem('post')).talk.display;
        this.allTalkData = {
            'uid': JSON.parse(localStorage.getItem('user')).uid,
            'token': JSON.parse(localStorage.getItem('user')).token,
            'curPage': this.index,
            'pageSize': JSON.parse(localStorage.getItem('post')).talk.display,
            'orderBy': JSON.parse(localStorage.getItem('post')).talk.orderBy,
            'order':JSON.parse(localStorage.getItem('post')).talk.order,
            'beginTime': JSON.parse(localStorage.getItem('post')).talk.beginTime,
            'endTime': JSON.parse(localStorage.getItem('post')).talk.endTime
        }
        this.http.server(JSON.parse(localStorage.getItem('todo')).talk.all, this.allTalkData).subscribe(
            allTalkResponse => {
                this.console.log('用户话题：',[]); // JSON.stringify(allTalkResponse.dataRows)
                this.allTalk = allTalkResponse.dataRows;
                this.allTalk.forEach((talk, index) => {
                    talk.medias = talk.media.split(',');
                });
            }
        );

    }

    // 下拉刷新
    // ---------------------------------
    doRefresh(refresher) {
        this.allTalkData = {
            'uid': JSON.parse(localStorage.getItem('user')).uid,
            'token': JSON.parse(localStorage.getItem('user')).token,
            'curPage': this.index,
            'pageSize': JSON.parse(localStorage.getItem('post')).talk.display,
            'orderBy': JSON.parse(localStorage.getItem('post')).talk.orderBy,
            'order':JSON.parse(localStorage.getItem('post')).talk.order,
            'beginTime': JSON.parse(localStorage.getItem('post')).talk.beginTime,
            'endTime': JSON.parse(localStorage.getItem('post')).talk.endTime
        }
        this.http.server(JSON.parse(localStorage.getItem('todo')).talk.all, this.allTalkData).subscribe(
            allTalkResponse => {
                this.console.log('下拉刷新：',[]); // JSON.stringify(allTalkResponse.dataRows)
                this.allTalk = allTalkResponse.dataRows;
                this.allTalk.forEach((talk, index) => {
                    talk.medias = talk.media.split(',');
                });
            }
        );
    }

    // 发表动态
    // ---------------------------------
    loadMore(){
        this.pageSize =  parseInt('10',this.pageSize) + 10;
        this.allTalkData = {
            'uid': JSON.parse(localStorage.getItem('user')).uid,
            'token': JSON.parse(localStorage.getItem('user')).token,
            'curPage': this.index,
            'pageSize': this.pageSize,
            'orderBy': JSON.parse(localStorage.getItem('post')).talk.orderBy,
            'order':JSON.parse(localStorage.getItem('post')).talk.order,
            'beginTime': JSON.parse(localStorage.getItem('post')).talk.beginTime,
            'endTime': JSON.parse(localStorage.getItem('post')).talk.endTime
        }

        this.http.server(JSON.parse(localStorage.getItem('todo')).talk.all, this.allTalkData).subscribe(
            allTalkResponse => {
                this.console.log('加载更多：',[]); // JSON.stringify(allTalkResponse.dataRows)
                allTalkResponse.dataRows.forEach((talk, index) => {
                    talk.medias = talk.media.split(',');
                });
                this.allTalk = allTalkResponse.dataRows;
            }
        );
    }

    // 话题详情
    // ---------------------------------  
    viewTalk(talk){
        this.nav.push(TalkView,{
            talk: talk
        });
    }

    // 发表动态
    // ---------------------------------
    postTalk(){
        //this.modal.open(TalkPost);
        this.nav.push(TalkPost);
    }



    // 页面生命周期
    // ---------------------------------
    //onPageLoaded(){
    //    //this.content = this.app.getComponent('talk-content');

    //    //this.content.onScrollEnd(console.log('滚动完成...'));
    //    //console.log('话题模板：' + this.content);
    //    this.console.log('TalkPage',['onPageLoaded','页面加载完成！']);
    //}

    onPageWillEnter(){
        if(localStorage.getItem('talkPost') == 'true'){
            this.http.server(JSON.parse(localStorage.getItem('todo')).talk.all, this.allTalkData).subscribe(
                allTalkResponse => {
                    this.console.log('返回刷新',[]); // JSON.stringify(allTalkResponse.dataRows)
                    this.allTalk = allTalkResponse.dataRows;
                    this.allTalk.forEach(talk => {
                        talk.medias = talk.media.split(',');
                    });
                },
                error => {
                    // TODO-错误页面
                }
            );
            
            localStorage.setItem('talkPost','false');
        }
        this.console.log('TalkPage',['onPageWillEnter','页面即将激活！']);
    }

    onPageDidEnter(){
        this.http.server(JSON.parse(localStorage.getItem('todo')).talk.all, this.allTalkData).subscribe(
    allTalkResponse => {
        this.console.log('返回刷新',[]); // JSON.stringify(allTalkResponse.dataRows)
        this.allTalk = allTalkResponse.dataRows;
        this.allTalk.forEach(talk => {
            talk.medias = talk.media.split(',');
        });
    },
    error => {
        // TODO-错误页面
    }
);
        this.console.log('TalkPage',['onPageDidEnter','页面已经激活！']);
    }

    //onPageWillLeave (){
    //    this.console.log('TalkPage',['onPageWillLeave','页面即将退出！']);
    //}

    //onPageDidLeave() {
    //    this.console.log('TalkPage',['onPageDidLeave','页面已经退出！']);
    //}

    //onPageWillUnload (){
    //    this.console.log('TalkPage',['onPageWillUnload','页面即将销毁！']);
    //}

    //onPageDidUnload (){
    //    this.console.log('TalkPage',['onPageDidUnload','页面已经销毁！']);
    //}
}
