﻿import {Page, Modal, Popup, Platform ,NavParams, NavController, ActionSheet} from 'ionic/ionic';
import {Control, Validators, ControlGroup} from 'angular2/angular2';

import {HttpService} from '../../../units/http';
import {ConsoleService} from '../../../units/console';


@Page({
    templateUrl: 'app/06.lover/starForbes/starForbes.html',
    providers: [HttpService, ConsoleService]
})
export class StarForbes {
    constructor(nav: NavController, popup: Popup, params: NavParams, modal: Modal, platform: Platform, actionSheet: ActionSheet,http: HttpService, console: ConsoleService) {
        this.nav = nav;
        this.popup = popup;
        this.modal = modal;
        this.platform = platform;
        this.actionSheet = actionSheet;

        this.http = http;
        this.console = console;


        // 初始化参数
        // ---------------------------------  

        let allStarData = {
            'uid': JSON.parse(localStorage.getItem('user')).uid,
            'token': JSON.parse(localStorage.getItem('user')).token,
            'curPage': '1',
            'pageSize': '25',
            'orderBy': 'hotCount',
            'order': 'desc'
        }
        this.http.server(JSON.parse(localStorage.getItem('todo')).star.top, allStarData).subscribe(
            allStarResponse => {
                this.console.log('明星排行',[JSON.stringify(allStarResponse.dataRows)]);
                this.stars = allStarResponse.dataRows;
            }
        );
        

    }


    //关注明星
    //---------------------------------  
    addStar(star){
        this.addStarData = {
            'uid': JSON.parse(localStorage.getItem('user')).uid,
            'token': JSON.parse(localStorage.getItem('user')).token,
            'starId': star.id
        }
        this.http.server(JSON.parse(localStorage.getItem('todo')).star.add, this.addStarData).subscribe(
            addStarResponse => {
                if(addStarResponse.flag && addStarResponse.isSuccess){
                    this.popup.alert({
                        title: "关注成功",
                        okText: '确定',
                        cssClass: 'my-alert'
                    }).then(() => {
                        //console.log('每日签到成功');
                    });
                }else{
                    this.popup.alert({
                        title: "你已关注该明星",
                        okText: '确定',
                        cssClass: 'my-alert'
                    }).then(() => {
                        //console.log('每日签到成功');
                    });
                }
                this.console.log('关注明星：',[JSON.stringify(addStarResponse)]); // JSON.stringify(newReplyResponse.dataRows)
            }
        );
    }
   

    // 页面生命周期
    // ---------------------------------
    //onPageLoaded(){
    //    this.console.log('TalkPost',['onPageLoaded','页面加载完成！']);
    //}

    //onPageWillEnter(){
    //    this.console.log('TalkPost',['onPageWillEnter','页面即将激活！']);
    //}

    //onPageDidEnter(){
    //    this.console.log('TalkPost',['onPageDidEnter','页面已经激活！']);
    //}

    //onPageWillLeave (){
    //    this.console.log('TalkPost',['onPageWillLeave','页面即将退出！']);
    //}

    //onPageDidLeave() {
    //    this.console.log('TalkPost',['onPageDidLeave','页面已经退出！']);
    //}

    //onPageWillUnload (){
    //    this.console.log('TalkPost',['onPageWillUnload','页面即将销毁！']);
    //}

    //onPageDidUnload (){
    //    this.console.log('TalkPost',['onPageDidUnload','页面已经销毁！']);
    //}
}
