﻿import {App, IonicApp, Popup, Platform, Config, Storage, LocalStorage, SqlStorage, Modal} from 'ionic/ionic';
//import {Device, StatusBar} from 'ionic-native';

import {HttpService} from '../units/http';
import {ConsoleService} from '../units/console';

import {MainPage} from './01.main/main';
import {LoginPage} from '../base/app/login/login';

import './app.scss';

@App({
    templateUrl: 'app/app.html',
    config: {
        backButtonText: '',
        tabSubPages: true,
        tabbarPlacement: 'bottom'
    },
    providers: [HttpService]
})
class InleadApp {
    constructor(app: IonicApp, platform: Platform, popup: Popup, config: Config, modal: Modal, http: HttpService) {


        this.app = app;
        this.modal = modal;
        this.popup = popup;
        this.platform = platform;

        //this.device = Device.getDevice();

        this.http = http;
        this.local = new Storage(LocalStorage);

        // 初始化首页 localStorage.getItem('user') && JSON.parse(localStorage.getItem('user')).token
        // ---------------------------------

        this.initializeApp();
        
        if(localStorage.getItem('user') && localStorage.getItem('user') != ''){
            // 自动登陆
            // ---------------------------------
            localStorage.removeItem('perfect');
            let loginData = {
                'id': JSON.parse(localStorage.getItem('user')).uid,
                'phoneNum': JSON.parse(localStorage.getItem('user')).tel
            }

            this.http.server(JSON.parse(localStorage.getItem('todo')).user.login,loginData).subscribe(
                data => {
                    if(data.flag && data.isSuccess){
                        let user = JSON.parse(localStorage.getItem('user'));
                        user.token = data.info;
                        localStorage.setItem('user',JSON.stringify(user));
                        localStorage.setItem('perfect','false');
                    }
                }
            );
            this.root = MainPage;
        }else{
            localStorage.setItem('perfect','true');
            this.root = LoginPage;
        }
        
    }

        // 初始化配置
        // ---------------------------------
        initializeApp(){
            this.platform.ready().then(() => {


                this.http.local('local/app.json').subscribe(
                    data =>{
                        // TODO-启动配置
                        this.local.set('app',JSON.stringify(data));
                        this.version = data.version;
                        // 强制更新
                        // ---------------------------------
                        let data = {
                            'uid':'',
                            'token':''
                        }
                        this.http.server('/getVersion.do',data).subscribe(
                            data => {
                                console.log('强制更新：' + JSON.stringify(data));
                                if(data.version > this.version && data.forcedUpdate == '1'){
                                    this.popup.alert({
                                        title: '检测到更新',
                                        okText: '立即更新'
                                    }).then(() => {
                                        window.location.href = 'http://120.55.119.89/install/download.html';
                                        navigator.app.exitApp();
                                        ionic.Platform.exitApp();
                                    });
                                    window.location.href = 'http://120.55.119.89/install/download.html';
                                    navigator.app.exitApp();
                                    ionic.Platform.exitApp();
                    }
                );

                this.http.local('local/todo.json').subscribe(
                    data =>{
                        // TODO-启动配置
                        this.local.set('todo',JSON.stringify(data));
                    }
                );

                this.http.local('local/post.json').subscribe(
                    data =>{
                        // TODO-启动配置
                        this.local.set('post',JSON.stringify(data));
                    }
                );
            });


            console.log('平台就绪！做点什么吧？',['什么都不做！']);
        
        }
    }
