﻿import {Page, IonicApp, Modal, Platform, NavController, ActionSheet, Camera} from 'ionic/ionic';
import {Validators, Control, ControlGroup} from 'angular2/angular2';

import {MainPage} from '../../../app/01.main/main';

import {HttpService} from '../../../units/http';
import {ConsoleService} from '../../../units/console';

@Page({
    templateUrl: 'base/app/perfect/perfect.html',
    providers: [ConsoleService]
})
export class PerfectPage {
    constructor(nav: NavController, app: IonicApp, modal: Modal, platform: Platform, actionSheet: ActionSheet, http: HttpService, console: ConsoleService) {

        this.nav = nav;
        this.app = app;
        this.modal = modal;
        this.platform = platform;
        this.actionSheet = actionSheet;

        this.http = http;
        this.console = console;

        this.isEnd = false;
        this.slideIndex = '0';
        this.isBeginning = true;

        this.prompt = '暂无提示';
        this.promptOpacity = 0.6;
        this.promptStyle = {
            'min-height':'0rem',
            'display':'none',
            'opacity': this.promptOpacity
        }

        this.isBelle = true;

        this.form = new ControlGroup({
            title: new Control('',Validators.required)
        });

        this.platform.is('android')? this.buttons = [
                  { text: '拍照', icon: 'camera'},
                  { text: '媒体库', icon: 'image' }
        ] : this.buttons = [
                  { text: '拍照'},
                  { text: '手机相册' }
        ]

        //this.uploader = new FileTransfer();
        this.qiniuTokenData = {
            'uid': JSON.parse(localStorage.getItem('user')).uid,
            'token': JSON.parse(localStorage.getItem('user')).token,
            'bucket': JSON.parse(localStorage.getItem('post')).qiniu.user.host,
            'expires': JSON.parse(localStorage.getItem('post')).qiniu.expires
        }

        this.http.server(JSON.parse(localStorage.getItem('todo')).qiniu.token, this.qiniuTokenData).subscribe(
            qiniuTokenResponse => {
                this.qiniuToken = qiniuTokenResponse.uptoken;
            }
        );

        this.added = [];


    }


    // 上传头像 & 昵称
    // ---------------------------------
    upload(){
        this.actionSheet.open({
            buttons: this.buttons,
            destructiveText: '',
            titleText: '上传头像',
            cancelText: '取消',
            cancel: () => {
                console.log('已取消！！');
            },
            destructiveButtonClicked: () => {
                // TODO-暂无删除
            },
            buttonClicked: (index) => {
                console.log('已选择：' + index);

                if (index == '0') { 
                    
                    navigator.camera.getPicture(
                        function (imageData) {
                            var image = document.getElementById('avatar');
                            image.src = "data:image/jpeg;base64," + imageData;
                            localStorage.setItem('userAvatar':imageData);
                            //this.avatar = 'data:image/jpeg;base64,' + imageData;
                        }, 
                       function (error) {

                       }, 
                       {
                           quality: 80,
                           destinationType: window.Camera.DestinationType.DATA_URL,
                           sourceType: window.Camera.PictureSourceType.CAMERA,
                           allowEdit: true,
                           encodingType: window.Camera.EncodingType.JPEG,
                           targetWidth: 400,
                           targetHeight: 400,
                           popoverOptions: window.CameraPopoverOptions,
                           saveToPhotoAlbum: false
                       });
                    this.actionSheetRef.close();
                }

                if(index == '1'){
                    navigator.camera.getPicture(
                            function (imageData) {
                                var image = document.getElementById('avatar');
                                image.src = "data:image/jpeg;base64," + imageData;
                                localStorage.setItem('userAvatar':imageData);
                                //this.avatar = 'data:image/jpeg;base64,' + imageData;
                            }, 
                           function (error) {

                           }, 
                           {
                               quality: 80,
                               destinationType: window.Camera.DestinationType.DATA_URL,
                               sourceType: window.Camera.PictureSourceType.SAVEDPHOTOALBUM,
                               allowEdit: true,
                               encodingType: window.Camera.EncodingType.JPEG,
                               targetWidth: 400,
                               targetHeight: 400,
                               popoverOptions: window.CameraPopoverOptions,
                               saveToPhotoAlbum: false
                           });
                    this.actionSheetRef.close();
                }
            }

        }).then(actionSheetRef => {
            this.actionSheetRef = actionSheetRef;
        });

        event.preventDefault();
    }



    // 上一页 & 下一页
    // ---------------------------------
    onSlideChanged(slider) {
        this.isBeginning = slider.isBeginning;
        this.isEnd = slider.isEnd;
    }


    // 上一步 & 下一步
    // ---------------------------------
    next(){
        console.log('当前索引：' + this.app.getComponent('slider').getIndex());
        switch(this.app.getComponent('slider').getIndex())
        {
            case 0:
                this.upTitle(this.form.value.title);
                if(localStorage.getItem('userAvatar')){
                    this.uploadAvatar();
                }
                this.upSex();
                break;
            case 1:
                // this.upSex();
                // break;
            case 2:
                // this.upAge();
                // 关注明星
            default:
                //n 与 case 1 和 case 2 不同时执行的代码
        }
    }

    prev(){
        this.app.getComponent('slider').prev();
    }

    // 关注明星
    // ---------------------------------
    pointerUp(star){
        if(!star.isAdd){
            star.style = {
                '-webkit-filter':'grayscale(100%)',
                '-moz-filter': 'grayscale(100%)',
                ' -ms-filter': 'grayscale(100%)',
                '-o-filter': 'grayscale(100%)', 
                'filter': 'grayscale(100%)',
                'filter': 'gray'
            }
            this.added.splice(this.added.indexOf(star.id),1);
            //this.added.forEach((id) => {
            //    console.log('删除：' + id);
            //});
        }else{
            star.style= {};
            this.added.push(star.id);
            //this.added.forEach((id) => {
            //    console.log('增加：' + id);
            //});
        }
    }
    
    // 完成
    // ---------------------------------
    done(){
        this.nav.push(MainPage);

        this.added.forEach((id) => {
            let addStarData = {
                'uid': JSON.parse(localStorage.getItem('user')).uid,
                'token': JSON.parse(localStorage.getItem('user')).token,
                'starId': id
            }
            this.http.server(JSON.parse(localStorage.getItem('todo')).star.add, addStarData).subscribe(
                addResponse => {
                    this.console.log('关注明星',[id, JSON.stringify(addResponse)]);
                },
                error => {
                }
            );
        });
    }


    // 完善信息：更新头像
    // ---------------------------------

    // 完善信息：更新昵称
    // ---------------------------------
    upTitle(title){
        let upTitleData = {
            'uid': JSON.parse(localStorage.getItem('user')).uid,
            'token': JSON.parse(localStorage.getItem('user')).token,
            'nickName': title
        }
        this.http.server(JSON.parse(localStorage.getItem('todo')).user.upTitle, upTitleData).subscribe(
            upTitleResponse => {
                this.console.log('更新昵称',[JSON.stringify(upTitleResponse)]);
                if(upTitleResponse.flag && upTitleResponse.isSuccess){
                    this.app.getComponent('slider').next();
                }else{
                    this.prompt = upTitleResponse.info == '昵称已存在' ? '昵称已存在，换一个试试！' : '提交失败，请稍后再试！';
                    this.promptStyle = {
                        'min-height':'0rem',
                        'display':'block',
                        'opacity': this.promptOpacity
                    }
                    setTimeout(() => {
                        let  timer = setInterval(() => {
                            if(this.promptOpacity <= 0){
                                clearInterval(timer);
                                this.promptOpacity = 0.6;
                                this.promptStyle = {
                                    'min-height':'0rem',
                                    'display':'none',
                                    'opacity': this.promptOpacity
                                }
                            }else{
                                this.promptStyle = {
                                    'min-height':'0rem',
                                    'display':'block',
                                    'opacity': this.promptOpacity
                                }
                                this.promptOpacity = this.promptOpacity - 0.02;
                            }
                        },50);
                    },5000);
                }
            },
            error => {
                this.prompt = '请求失败，请稍后再试！';
                this.promptStyle = {
                    'min-height':'0rem',
                    'display':'block',
                    'opacity': this.promptOpacity
                }
                setTimeout(() => {
                    let  timer = setInterval(() => {
                        if(this.promptOpacity <= 0){
                            clearInterval(timer);
                            this.promptOpacity = 0.6;
                            this.promptStyle = {
                                'min-height':'0rem',
                                'display':'none',
                                'opacity': this.promptOpacity
                            }
                        }else{
                            this.promptStyle = {
                                'min-height':'0rem',
                                'display':'block',
                                'opacity': this.promptOpacity
                            }
                            this.promptOpacity = this.promptOpacity - 0.02;
                        }
                    },50);
                },5000);
            }
        );
    }

    // 完善信息：更改性别 & 更新性别
    // ---------------------------------
    changeSex(event){
        this.isBelle = !this.isBelle;
        event.preventDefault();
    }

    upSex(){
        this.isEnd = true;
        this.isBelle = '3';
        let upSexData = {
            'uid': JSON.parse(localStorage.getItem('user')).uid,
            'token': JSON.parse(localStorage.getItem('user')).token,
            'sex': this.isBelle ? '0' : '1'
        }
        this.http.server(JSON.parse(localStorage.getItem('todo')).user.upSex, upSexData).subscribe(
            upSexResponse => {
                this.console.log('更新性别',[JSON.stringify(upSexResponse)]);
                if(upSexResponse.flag && upSexResponse.isSuccess){
                    this.topStar();
                    this.app.getComponent('slider').next();
                }else{
                    this.prompt = '提交失败，请稍后再试！';
                    this.promptStyle = {
                        'min-height':'0rem',
                        'display':'block',
                        'opacity': this.promptOpacity
                    }
                    setTimeout(() => {
                        let  timer = setInterval(() => {
                            if(this.promptOpacity <= 0){
                                clearInterval(timer);
                                this.promptOpacity = 0.6;
                                this.promptStyle = {
                                    'min-height':'0rem',
                                    'display':'none',
                                    'opacity': this.promptOpacity
                                }
                            }else{
                                this.promptStyle = {
                                    'min-height':'0rem',
                                    'display':'block',
                                    'opacity': this.promptOpacity
                                }
                                this.promptOpacity = this.promptOpacity - 0.02;
                            }
                        },50);
                    },5000);
                }
            },
            error => {
                this.prompt = '请求失败，请稍后再试！';
                this.promptStyle = {
                    'min-height':'0rem',
                    'display':'block',
                    'opacity': this.promptOpacity
                }
                setTimeout(() => {
                    let  timer = setInterval(() => {
                        if(this.promptOpacity <= 0){
                            clearInterval(timer);
                            this.promptOpacity = 0.6;
                            this.promptStyle = {
                                'min-height':'0rem',
                                'display':'none',
                                'opacity': this.promptOpacity
                            }
                        }else{
                            this.promptStyle = {
                                'min-height':'0rem',
                                'display':'block',
                                'opacity': this.promptOpacity
                            }
                            this.promptOpacity = this.promptOpacity - 0.02;
                        }
                    },50);
                },5000);
            }
        );
    }

    // 完善信息：TODO-更新年龄
    // ---------------------------------
    upAge(){
        
    }

    // 完善信息：热门明星 & 关注明星
    // ---------------------------------
    topStar(){
        let topStarData = {
            'uid': JSON.parse(localStorage.getItem('user')).uid,
            'token': JSON.parse(localStorage.getItem('user')).token,
            'curPage': '1',
            'pageSize': '4',
            'orderBy':'id',
            'order':'desc'
        }
        this.http.server(JSON.parse(localStorage.getItem('todo')).star.top, topStarData).subscribe(
            topStarResponse => {
                this.console.log('热门明星',[JSON.stringify(topStarResponse.dataRows)]);
                this.stars = topStarResponse.dataRows;
                this.stars.forEach((star) => {
                    star.isAdd = true;
                    star.style = {};
                    this.added.push(star.id);
                });
            }
        );

        let topStarData4 = {
            'uid': JSON.parse(localStorage.getItem('user')).uid,
            'token': JSON.parse(localStorage.getItem('user')).token,
            'curPage': '2',
            'pageSize': '4',
            'orderBy':'id',
            'order':'desc'
        }
        this.http.server(JSON.parse(localStorage.getItem('todo')).star.top, topStarData4).subscribe(
            topStarResponse => {
                this.console.log('热门明星',[JSON.stringify(topStarResponse.dataRows)]);
                this.stars4 = topStarResponse.dataRows;
                this.stars4.forEach((star) => {
                    star.isAdd = true;
                    star.style = {};
                    this.added.push(star.id);
                });
            },
            error => {
            
            }
        );

        let topStarData8 = {
            'uid': JSON.parse(localStorage.getItem('user')).uid,
            'token': JSON.parse(localStorage.getItem('user')).token,
            'curPage': '3',
            'pageSize': '4',
            'orderBy':'id',
            'order':'desc'
        }
        this.http.server(JSON.parse(localStorage.getItem('todo')).star.top, topStarData8).subscribe(
            topStarResponse => {
                this.console.log('热门明星',[JSON.stringify(topStarResponse.dataRows)]);
                this.stars8 = topStarResponse.dataRows;
                this.stars8.forEach((star) => {
                    star.isAdd = true;
                    star.style = {};
                    this.added.push(star.id);
                });
            },
            error => {
            
            }
        );
    }
    
    uploadAvatar(){
        if(localStorage.getItem('userAvatar')){
            this.http.uploader(this.qiniuToken, localStorage.getItem('userAvatar')).subscribe(
            data => {
                console.log('上传头像：' + JSON.stringify(data));
                this.avatarUrl =  JSON.parse(localStorage.getItem('post')).qiniu.user.http + data.key;
                if(data.hash){
                    localStorage.removeItem('userAvatar');

                    let userAvatarData = {
                        'uid': JSON.parse(localStorage.getItem('user')).uid,
                        'token': JSON.parse(localStorage.getItem('user')).token,
                        'headPic' : this.avatarUrl
                    }
                    this.http.server(JSON.parse(localStorage.getItem('todo')).user.upAvatar, userAvatarData).subscribe(
                        data => {
                            console.log('更新头像：' + JSON.stringify(data));
                        }    
                    );
                }
            }
        );
        }
        
    }

    // 页面生命周期
    // ---------------------------------
    //onPageLoaded(){
    //    this.console.log('PerfectPage',['onPageLoaded','页面加载完成！']);
    //}
    //onPageWillEnter(){
    //    this.console.log('PerfectPage',['onPageWillEnter','页面即将激活！']);
    //}

    //onPageDidEnter(){
    //    this.console.log('PerfectPage',['onPageDidEnter','页面已经激活！']);
    //}

    //onPageWillLeave (){
    //    this.console.log('PerfectPage',['onPageWillLeave','页面即将退出！']);
    //}

    //onPageDidLeave() {
    //    this.console.log('PerfectPage',['onPageDidLeave','页面已经退出！']);
    //}

    //onPageWillUnload (){
    //    this.console.log('PerfectPage',['onPageWillUnload','页面即将销毁！']);
    //}

    //onPageDidUnload (){
    //    this.console.log('PerfectPage',['onPageDidUnload','页面已经销毁！']);
    //}
}
